# Working With Modules

- Introduction
- Return Values
- Module Maintenance & Support

Ansible ships with a number of modules (called the ‘module library’) that can be executed directly on remote hosts or through Playbooks.

Users can also write their own modules. These modules can control system resources, like services, packages, or files (anything really), or handle executing system commands.

See also

Introduction To Ad-Hoc Commands
  Examples of using modules in /usr/bin/ansible
Working With Playbooks
  Examples of using modules with /usr/bin/ansible-playbook
Should you develop a module?
  How to write your own modules
Python API
  Examples of using modules with the Python API
Mailing List
  Questions? Help? Ideas? Stop by the list on Google Groups
irc.freenode.net
  #ansible IRC chat channel